/** Functionality to handle telecommands. */
// *** AUTOGENERATED FILE - Do not edit manually! - Changes will be overwritten! *** //

#pragma once

#include "generated/units.h"
#include "generated/sharedTypes.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Handle a received telecommand.
 *
 * @param telecommand The telecommand that was received.
 * @return Whether the telecommand could be handled.
 */
extern bool handleTelecommand(const TelecommandData* telecommand);

/**
 * Handle the SET_LAST_STATE telecommand.
 * 
 * @param state The new state that will be set as last state.
 */
extern void handleCommandSetLastState(SystemState state);

/**
 * Handle the GET_LAST_STATE telecommand.
 * 
 * @return The last system state.
 */
extern SystemState handleCommandGetLastState(void);

/** Handle the NEW_LOG_FILE telecommand. */
extern void handleCommandNewLogFile(void);

/**
 * Handle the RESET_CHIP telecommand.
 * 
 * @param verificationCode A code that needs to match the predefined value for the chip to get
 * reset.
 */
extern void handleCommandResetChip(uint32_t verificationCode);

/**
 * Handle the SET_CURRENT_STATE telecommand.
 * 
 * @param state The current state of the system state machine.
 */
extern void handleCommandSetCurrentState(SystemState state);

/**
 * Handle the GET_CURRENT_STATE telecommand.
 * 
 * @return The current system state.
 */
extern SystemState handleCommandGetCurrentState(void);

/**
 * Handle the SET_FLIGHT telecommand.
 * 
 * @param verificationCode A code that needs to match the predefined value to confirm the change.
 * @param enable Whether or not flight mode should be enabled.
 */
extern void handleCommandSetFlight(uint32_t verificationCode, bool enable);

/**
 * Handle the GET_FLIGHT telecommand.
 * 
 * @return Whether or not the flight mode is enabled.
 */
extern bool handleCommandGetFlight(void);

/**
 * Handle the SET_PRE_LAUNCH_TIMER telecommand.
 * 
 * @param timer The new value of the pre launch timer in milliseconds since pre-launch started.
 */
extern void handleCommandSetPreLaunchTimer(ms_t timer);

/**
 * Handle the SET_VIDEO_ENABLED telecommand.
 * 
 * @param enabled Whether or not the GoPros should be enabled.
 */
extern void handleCommandSetVideoEnabled(bool enabled);

/** Handle the RESET_RECOVERY telecommand. */
extern void handleCommandResetRecovery(void);

/**
 * Handle the MOTOR_ENABLED telecommand.
 * 
 * @param enabled Whether or not the motors should be enabled.
 */
extern void handleCommandMotorEnabled(bool enabled);

/**
 * Handle the MOTOR_WARMUP telecommand.
 * 
 * @param enabled Whether or not the motor warmup sequence should be enabled.
 */
extern void handleCommandMotorWarmup(bool enabled);

/**
 * Handle the SET_PWM telecommand.
 * 
 * @param value The new pwm value for the motors.
 */
extern void handleCommandSetPwm(pwm_t value);

/**
 * Handle the SET_RPM telecommand.
 * 
 * @param value The new rpm value for the motors.
 */
extern void handleCommandSetRpm(rpm_t value);

/**
 * Handle the SET_ADCS_MODE telecommand.
 * 
 * @param mode The new ADCS mode.
 */
extern void handleCommandSetAdcsMode(AdcsMode mode);

/** Handle the DEPLOY_PARACHUTE telecommand. */
extern void handleCommandDeployParachute(void);

/** Handle the SEND_IRIDIUM_MESSAGE telecommand. */
extern void handleCommandSendIridiumMessage(void);

/**
 * Handle the CALIBRATE_IMU telecommand.
 * 
 * @param imu The IMU to calibrate.
 * @return Whether or not the calibration was successful.
 */
extern bool handleCommandCalibrateImu(uint8_t imu);

/**
 * Handle the SET_PAYLOAD_VIDEO telecommand.
 * 
 * @param enabled Whether or not the payload should record video.
 */
extern void handleCommandSetPayloadVideo(bool enabled);

/**
 * Handle the SET_RECOVERY_STATE telecommand.
 * 
 * @param state The target state of the recovery system.
 */
extern void handleCommandSetRecoveryState(RecoveryState state);


#ifdef __cplusplus
}
#endif
